/**
 * Defines events that the layout system emits
 *
 * 'firstLoaded' - emitted when the layout has finished loading the first time
 * using the declarative API after {@link DEFAULT_RELOAD_BUFFER} ms.
 * <br/>
 * 'itemAdded' - emitted when an item is added to the layout'
 * <br/>
 * 'itemRemoved' - emitted when an item is removed from the layout'
 * @beta
 */
export const LayoutEmitEvents = {
    firstLoaded: 'first-loaded',
    itemAdded: 'item-added',
    itemRemoved: 'item-removed',
};
/**
 * Defines events that the layout system listens for
 *
 * 'changeTitle' - emit this from a contained item to update the title of the window that contains it.
 * @beta
 */
export const LayoutReceiveEvents = {
    changeTitle: 'change-title',
};
//# sourceMappingURL=events.js.map