## API Report File for "@genesislcap/foundation-layout"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import type { Container } from '@microsoft/fast-foundation';
import { ElementStyles } from '@microsoft/fast-element';
import { FoundationElement } from '@microsoft/fast-foundation';
import { FoundationElementRegistry } from '@microsoft/fast-foundation';
import { OverrideFoundationElementDefinition } from '@microsoft/fast-foundation';
import { ResolvedLayoutConfig } from '@genesis-community/golden-layout';
import { RootItemConfig } from '@genesis-community/golden-layout';
import { ViewTemplate } from '@microsoft/fast-element';

// Warning: (ae-internal-missing-underscore) The name "componentType" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export const componentType: unique symbol;

// Warning: (ae-internal-missing-underscore) The name "ComponentTypes" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type ComponentTypes = LayoutRegionType | 'root' | 'item';

// @beta
export const DEFAULT_RELOAD_BUFFER = 500;

// Warning: (ae-incompatible-release-tags) The symbol "FoundationLayout" is marked as @beta, but its signature references "LayoutComponent" which is marked as @internal
//
// @beta
export class FoundationLayout extends FoundationElement implements LayoutComponent {
    // @internal (undocumented)
    [componentType]: "root";
    // @internal
    constructor();
    addItem(config: RegisteredElementConfig, placement?: Placement): void;
    // @internal
    addItemFromChild<T extends RootItemConfig>(item: T): T;
    // @internal
    cacheElementsAndRegister({ elements, id }: RegistrationConfig): string;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    disconnectedCallback(): void;
    dragging: boolean;
    getLayout(): SerialisedLayout;
    // @internal (undocumented)
    hasFirstLoaded: boolean;
    // @internal (undocumented)
    layoutElement: HTMLElement;
    static layoutRequiredRegistrations(layout: SerialisedLayout): string[];
    loadLayout(layout: SerialisedLayout): void;
    registeredItems(): string[];
    registerItem(registration: string, elements: Element[]): string;
    reloadBuffer: number;
    // @internal
    requestLayoutReload(): void;
    // @internal (undocumented)
    usingDeclerativeAPI: boolean;
}

// @beta
export const foundationLayoutComponents: {
    foundationLayout: (overrideDefinition?: OverrideFoundationElementDefinition<    {
    baseName: string;
    styles: ElementStyles;
    template: ViewTemplate<FoundationLayout, any>;
    }>) => FoundationElementRegistry<    {
    baseName: string;
    styles: ElementStyles;
    template: ViewTemplate<FoundationLayout, any>;
    }, FoundationLayout>;
    foundationLayoutRegion: (overrideDefinition?: OverrideFoundationElementDefinition<    {
    baseName: string;
    template: ViewTemplate<any, any>;
    }>) => FoundationElementRegistry<    {
    baseName: string;
    template: ViewTemplate<any, any>;
    }, FoundationLayoutRegion>;
    foundationLayoutItem: (overrideDefinition?: OverrideFoundationElementDefinition<    {
    baseName: string;
    template: ViewTemplate<any, any>;
    }>) => FoundationElementRegistry<    {
    baseName: string;
    template: ViewTemplate<any, any>;
    }, FoundationLayoutItem>;
    register(container?: Container, ...rest: any[]): void;
};

// Warning: (ae-incompatible-release-tags) The symbol "FoundationLayoutItem" is marked as @beta, but its signature references "LayoutComponent" which is marked as @internal
//
// @beta
export class FoundationLayoutItem extends FoundationElement implements LayoutComponent {
    // @internal (undocumented)
    [componentType]: "item";
    // @internal (undocumented)
    cacheElementsAndRegister(config: RegistrationConfig): string;
    closable: boolean;
    // @internal (undocumented)
    connectedCallback(): void;
    registration: string;
    // @internal (undocumented)
    requestLayoutReload(): void;
    size: string;
    title: string;
}

// Warning: (ae-incompatible-release-tags) The symbol "FoundationLayoutRegion" is marked as @beta, but its signature references "LayoutComponent" which is marked as @internal
//
// @beta
export class FoundationLayoutRegion extends FoundationElement implements LayoutComponent {
    // @internal (undocumented)
    [componentType]: LayoutRegionType;
    // @internal (undocumented)
    addItemFromChild<T extends RootItemConfig>(item: T): T;
    // @internal (undocumented)
    cacheElementsAndRegister(config: RegistrationConfig): string;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    requestLayoutReload(): void;
    size: string;
    type: LayoutRegionType;
}

// Warning: (ae-internal-missing-underscore) The name "getMissingArrayItems" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export function getMissingArrayItems<T>(a: T[], b: T[]): T[];

// Warning: (ae-internal-missing-underscore) The name "getParentLayoutComponent" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export function getParentLayoutComponent(): FoundationLayout | FoundationLayoutRegion;

// Warning: (ae-internal-missing-underscore) The name "LayoutComponent" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export interface LayoutComponent {
    // (undocumented)
    [componentType]: ComponentTypes;
    // (undocumented)
    cacheElementsAndRegister(config: RegistrationConfig): string;
    // (undocumented)
    requestLayoutReload(): void;
}

// @beta
export const LayoutEmitEvents: {
    readonly firstLoaded: "first-loaded";
    readonly itemAdded: "item-added";
    readonly itemRemoved: "item-removed";
};

// @beta
export const LayoutReceiveEvents: {
    readonly changeTitle: "change-title";
};

// @beta
export type LayoutReceiveEventsDetail = {
    changeTitle: {
        title: string;
        mode: 'replace' | 'suffix';
    };
};

// Warning: (ae-incompatible-release-tags) The symbol "LayoutRegionType" is marked as @beta, but its signature references "layoutRegionValue" which is marked as @internal
//
// @beta
export type LayoutRegionType = (typeof layoutRegionValue)[number];

// Warning: (ae-internal-missing-underscore) The name "layoutRegionValue" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const layoutRegionValue: readonly ["horizontal", "vertical", "tabs"];

// @beta (undocumented)
export class LayoutRegistrationError extends Error {
    constructor(message: string);
}

// @beta
export const layoutStyles: ElementStyles;

// @beta
export const layoutTemplate: ViewTemplate<FoundationLayout, any>;

// @beta (undocumented)
export class LayoutUsageError extends Error {
    constructor(message: string);
}

// @beta
export type Placement = {
    area: 'top' | 'left' | 'bottom' | 'right';
};

// @beta
export interface RegisteredElementConfig {
    // (undocumented)
    closable?: boolean;
    // (undocumented)
    registration: string;
    // (undocumented)
    size?: string;
    // (undocumented)
    title?: string;
}

// Warning: (ae-internal-missing-underscore) The name "RegistrationConfig" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export interface RegistrationConfig {
    // (undocumented)
    elements: Element[];
    // (undocumented)
    id?: string;
}

// @beta
export type SerialisedLayout = {
    v: '1';
    c: ResolvedLayoutConfig;
};

// Warning: (ae-internal-missing-underscore) The name "wrapperTemplate" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export const wrapperTemplate: ViewTemplate<any, any>;

// (No @packageDocumentation comment for this package)

```
