<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-layout](./foundation-layout.md) &gt; [FoundationLayout](./foundation-layout.foundationlayout.md)

## FoundationLayout class

> This API is provided as a preview for developers and may change based on feedback that we receive. Do not use this API in a production environment.
> 

Top level web component which is used to initialise a custom layout

**Signature:**

```typescript
export declare class FoundationLayout extends FoundationElement implements LayoutComponent 
```
**Extends:** FoundationElement

**Implements:** LayoutComponent

## Remarks

Can be used in a composition to customise the styles of the layout.

The constructor for this class is marked as internal. Third-party code should not call the constructor directly or create subclasses that extend the `FoundationLayout` class.

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [dragging](./foundation-layout.foundationlayout.dragging.md) |  | boolean | **_(BETA)_** Set to true when the user is currently dragging the panes inside of the layout |
|  [reloadBuffer](./foundation-layout.foundationlayout.reloadbuffer.md) |  | number | **_(BETA)_** Number describing how long to wait in ms before reloading the config when adding items declaratively by the html API. Default 500 (ms). |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [addItem(config, placement)](./foundation-layout.foundationlayout.additem.md) |  | **_(BETA)_** Dynamically add a new item to the layout. The user can move the new plane to whenever they want once it has been added. |
|  [getLayout()](./foundation-layout.foundationlayout.getlayout.md) |  | **_(BETA)_** Gets a minified string containing the config describing the current layout of the layout object to later restore in [function](./foundation-layout.foundationlayout.loadlayout.md) |
|  [layoutRequiredRegistrations(layout)](./foundation-layout.foundationlayout.layoutrequiredregistrations.md) | <code>static</code> | **_(BETA)_** Gets all of the required registration function names for a set of config |
|  [loadLayout(layout)](./foundation-layout.foundationlayout.loadlayout.md) |  | **_(BETA)_** Restores a layout described in the config from [getLayout()](./foundation-layout.foundationlayout.getlayout.md) |
|  [registeredItems()](./foundation-layout.foundationlayout.registereditems.md) |  | **_(BETA)_** Gets all of the currently registered names |
|  [registerItem(registration, elements)](./foundation-layout.foundationlayout.registeritem.md) |  | **_(BETA)_** Register a collection of <code>Element</code> and associate them with an <code>ID</code> with the layout system for later use. |

