<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-layout](./foundation-layout.md)

## foundation-layout package

## Classes

|  Class | Description |
|  --- | --- |
|  [FoundationLayout](./foundation-layout.foundationlayout.md) | **_(BETA)_** Top level web component which is used to initialise a custom layout |
|  [FoundationLayoutItem](./foundation-layout.foundationlayoutitem.md) | **_(BETA)_** <code>FoundationLayoutItem</code> is a custom element that represents an item in the layout. |
|  [FoundationLayoutRegion](./foundation-layout.foundationlayoutregion.md) | **_(BETA)_** <code>FoundationLayoutRegion</code> is a custom element that represents a region in the layout. |
|  [LayoutRegistrationError](./foundation-layout.layoutregistrationerror.md) | **_(BETA)_** |
|  [LayoutUsageError](./foundation-layout.layoutusageerror.md) | **_(BETA)_** |

## Interfaces

|  Interface | Description |
|  --- | --- |
|  [RegisteredElementConfig](./foundation-layout.registeredelementconfig.md) | **_(BETA)_** The parameters that can be set on a new item when being added by the [FoundationLayout.addItem()](./foundation-layout.foundationlayout.additem.md) API |

## Variables

|  Variable | Description |
|  --- | --- |
|  [DEFAULT\_RELOAD\_BUFFER](./foundation-layout.default_reload_buffer.md) | <p>**_(BETA)_** Default time in milliseconds for the layout to buffer calls to reloading the layout while the declarative API is loading.</p><p>During the first load of the layout, a loading spinner will be shown.</p> |
|  [foundationLayoutComponents](./foundation-layout.foundationlayoutcomponents.md) | **_(BETA)_** Registration object to register the layout with your design system. |
|  [LayoutEmitEvents](./foundation-layout.layoutemitevents.md) | <p>**_(BETA)_** Defines events that the layout system emits</p><p>'firstLoaded' - emitted when the layout has finished loading the first time using the declarative API after [DEFAULT\_RELOAD\_BUFFER](./foundation-layout.default_reload_buffer.md) ms. <br/> 'itemAdded' - emitted when an item is added to the layout' <br/> 'itemRemoved' - emitted when an item is removed from the layout'</p> |
|  [LayoutReceiveEvents](./foundation-layout.layoutreceiveevents.md) | <p>**_(BETA)_** Defines events that the layout system listens for</p><p>'changeTitle' - emit this from a contained item to update the title of the window that contains it.</p> |
|  [layoutStyles](./foundation-layout.layoutstyles.md) | **_(BETA)_** <code>ElementStyles</code> which defines the css for [FoundationLayout](./foundation-layout.foundationlayout.md)<!-- -->. |
|  [layoutTemplate](./foundation-layout.layouttemplate.md) | **_(BETA)_** <code>ViewTemplate</code> which defines the html for [FoundationLayout](./foundation-layout.foundationlayout.md)<!-- -->. |

## Type Aliases

|  Type Alias | Description |
|  --- | --- |
|  [LayoutReceiveEventsDetail](./foundation-layout.layoutreceiveeventsdetail.md) | <p>**_(BETA)_** Defines the shape of the detail that the layout listens works with for events it listens on</p><p>'changeTitle' - <code>title</code> is the string you want to set. For <code>mode</code>: <code>replace</code> will set the title to be <code>title</code>, <code>suffix</code> will append <code>title</code> to the end of the existing title.</p> |
|  [LayoutRegionType](./foundation-layout.layoutregiontype.md) | **_(BETA)_** Union type describing the three different types of region splits. Set on the <code>type</code> attribute on [FoundationLayoutRegion](./foundation-layout.foundationlayoutregion.md)<!-- -->. |
|  [Placement](./foundation-layout.placement.md) | **_(BETA)_** Where to add the new item into the layout when using the [FoundationLayout.addItem()](./foundation-layout.foundationlayout.additem.md) API |
|  [SerialisedLayout](./foundation-layout.serialisedlayout.md) | **_(BETA)_** Versioned layout config objects. <code>v</code> is the version and <code>c</code> contains the layout config. |

